• 如果您觉得本站非常有看点,那么赶紧使用Ctrl+D 收藏吧

Shell脚本最佳实践

开发技术 开发技术 2个月前 (08-23) 52次浏览

Shell脚本最佳实践

0. 编码、缩进、文件命名和权限设置等

使用utf-8编码;
统一使用tab缩进或空格缩进,不要混用;
文件名以.sh结尾,并且统一风格;
添加可执行权限:

chmod +x [bash_script.sh]

最后,在所有输出完毕后,添加一个空行。

1. 指定默认解释器

也就是不要省略脚本第一行的shebang,一般默认是bash:

#!/bin/bash

或者更为通用一些:

#!/usr/bin/env bash

本机可用的shell解释器,可以通过以下命令查看:

cat /etc/shells

2. Shell环境设置

设置命令回显:

set -x

shell默认设置不够友好,我们希望予以加强。

# 遇到未声明的变量则报错停止
set -u
# 遇到执行错误则停止
set -e

由于set -e对管道命令无效,管道命令其中一步失败则中止,需要使用:

set -o pipefail

我们将这三条合并,构成 bash strict mode,添加在bash脚本的开始位置:

set -euo pipefail

因为这里都是shell环境设置,所以也可以在执行脚本的时候来使用:

bash -euo pipefail [bash_sctipt.sh]

3. 条件判断。

使用 [[ ]] 并在每个变量和运算符以及和括号之间加入一个空格,例如:

if [[ $# > 1 ]] || [[ $# == 1 && $1 != 'PC' && $1 != 'server' ]]; then
      echo 'Invalid commandline arguments, you should use `./run.sh` or `./run.sh PC` or `./run.sh server`'
      exit 1
fi

其中,$#用于获取命令行参数个数,$N用于获取第N个命令行参数参数$0指的是脚本文件名。
相比单方括号,双方括号的优势在于可以直接使用比较运算符>``<``==``!=等,而不是必须使用-gt``-lt``-eq``-ne;此外双方括号可以使用&&``||来表达与和或,而不用必须写-a``-o这种难以记忆的写法。

4. 使用文件之前判断是否存在,并进行异常处理。

# 判断普通文件存在
if [[ ! -f 'a.txt' ]]; then
      touch 'a.txt'
fi
# 判断文件夹存在
if [[ ! -d 'src' ]]; then
      echo 'src dir not found'
      exit 1
fi

注意cp -r命令,在文件夹不存在时回创建文件夹并复制,而当文件夹存在时,会复制到子文件夹内。

5. 循环语句。

提倡使用for-in循环

# C风格
for (( i=0; i<10; i++)); do
      // echo $i
done
# for-in
for i in $(seq 0 9); do
      // echo $i
done

和 if 语句的 then 一样,for 语句的 do 也紧跟在语句后面,不单独占一行,这样显得比较紧凑。同样不要忘记加分号。

6. 总是使用main函数包裹执行体

main() {
      func1()
      func2()
}
main "$@"

python类似,shell不需要函数入口,可以从第一条指令开始执行。但是为了可读性和方便调试,我们总是写一个命名为main的函数来作为全局入口。

7. 变量

1)环境变量的设置和取消:

# 设置环境变量
export SKIP_BFS=1
# 取消环境变量
unset SKIP_BFS

2)局部变量
shell变量默认全局作用域,这一点与JavaScript类似,函数内声明局部变量,应该添加local关键字。

3)使用变量时,总是用双引号把变量包起来,例如:

# 带空格的路径
cp -r "$src_dir" "$dest_dir"

路径有空格会导致很严重的bug,用"$var"这种写法,避免了这个问题。

8. 使用$()而不是反引号获取表达式的值

如for-in:

# 建议使用 $(seq lb ub) 而不是 `seq lb ub` 获取范围
for i in $(seq 0 10) do 
      echo $i
done

9. 使用 /dev/null 过滤输出信息

[expr] > /dev/null 2>&1

命令解释:重定向到空设备,并把标准错误输出stderr也重定向为stdout。
注意,2>&1应该总是放在命令的末尾。

10. case语句等

TBD

更多细节,参考Google Bash风格指南


喜欢 (0)